AA-KILL(1)

NAME
aa-kill - Send signals to (almost) all processes

SYNOPSIS
aa-kill [-D] [-u] [-t] [-k] [-s]

OPTIONS

-D, --double-output
    Enable double-output mode. Instead of using stdout for regular output, and stderr for warnings and errors, everything is sent both to stdout and stderr. This is intended to redirect stderr to a log file, so full output can be both shown on console and logged.

-h, --help
    Show help screen and exit.

-k, --kill
    Send SIGKILL

-s, --skip
    Skip processes whose argv[0][0] is '@' This can be useful to ignore some long-running processes that needs to be dealt with e.g. back in the initramfs, only after umounting the root filesystem.

-t, --term
    Send SIGTERM then SIGCONT

-u, --hup
    Send SIGHUP

-V, --version
    Show version information and exit.

DESCRIPTION
aa-kill(1) can be used to send signals to (almost) all running processes. It is for example used during stage 3, after aa-stop(1) and before aa-pivot(1) to kill any & all procesess that may have not been stopped otherwise.

By default it sends nothing, so at least one of --hup, --term or --kill must be specified. You can combine them to send all specified signals. They will always be sent in that order (SIGHUP, SIGTERM/SIGCONT, SIGKILL).

If --skip was not used, signals are sent using kill(3) with a pid of -1. If --skip was used, aa-kill(1) will then scan through /proc to list all running processes, and check their argv[0][0] (i.e. /proc/PID/cmdline) to skip any that starts with an '@' Also skipped will be process without cmdline (i.e. kernel threads), PID 1, and aa-kill(1) itself.

Note that aa-kill(1) will ignore the signals it sends when --skip isn't used, though that won't do much against SIGKILL.

BUGS
They're probably crawling somewhere in there... if you happen to catch one, (or more) report it and I'll do my best to squash it.

REPOSITORY
You can find the latest source code of anopa as well as report bugs and/or suggest features on its GitHub repository, available at <https://github.com/jjk-jacky/anopa>; or visit its official website at <https://jjacky.com/anopa>

AUTHOR

Olivier Brunel <jjk@jjacky.com>